#include <stdio.h>
#include <stdlib.h>

/*** Podaci i funkcija iz zadatka -- ovo nije dio rjesenja! ***/

typedef struct {
  int id;
  int sef;
  int placa;
} tip_radnik;

int intcmp(const void *x, const void *y) {
  return *(int*)x - *(int*)y;
}

int radnik(int id, int *sef, int *placa, int *n, int podredjeni[]) {
  static const tip_radnik radnici[] = {
    { 17,  0, 171923 },
    { 13, 17, 1317 },
    { 11, 13, 1117 },
    {  7, 17, 1737 },
    {  5, 13, 503 },
    {  3, 17, 1111 },
    { 19,  0, 171311 },
    { 23, 19, 1923 },
    { 31, 19, 1117 },
    { 29, 31, 1331 },
    { 37, 29, 1357 }
  };
  static const int radniciCnt = sizeof(radnici) / sizeof(tip_radnik);
  int i, found = 0;
  *n = 0;
  for (i = 0; i < radniciCnt; i++) {
    if (radnici[i].id == id) {
      found = 1;
      *sef = radnici[i].sef;
      *placa = radnici[i].placa;
    } else if (radnici[i].sef == id)
      podredjeni[(*n)++] = radnici[i].id;
  }
  qsort(podredjeni, *n, sizeof(int), intcmp);
  return found;
}

/*** Ovo je rjesenje zadatka ***/

int glavni_sef(int id) {
  int sef, placa, n, podredjeni[68];
  while (radnik(id, &sef, &placa, &n, podredjeni)) {
    if (!sef) return id;
    id = sef;
  }
  return 0;
}

int glavni_sef_rekurzivna_verzija(int id) {
  int sef, placa, n, podredjeni[68];
  if (!radnik(id, &sef, &placa, &n, podredjeni)) return 0; /* nema takvog */
  if (sef) return glavni_sef_rekurzivna_verzija(sef); /* trazi sefovog glavnog sefa */
  return id; /* nema sefa, dakle on je glavni sef */
}

void svi_podsefovi(int id) {
  /* funkcija ispisuje sve koji su indirektno podredjeni id-u, a nekome su sefovi */
  int sef, placa, n, podredjeni[68];
  radnik(id, &sef, &placa, &n, podredjeni);
  if (n) {
    int i;
    printf(" %d (placa: %d)", id, placa);
    for (i = 0; i < n; i++) svi_podsefovi(podredjeni[i]);
  }
}

void svi_sefovi(int id) {
  id = glavni_sef(id);
  if (!id) return; /* nepostojeci zaposlenik */
  svi_podsefovi(id);
}

/*** Kraj rjesenja ***/

/*** Grupa B je identicna -- pobjednik je ekvivalentan glavnom sefu, a prvoporazeni zaposlenicima bez podredjenih ***/

void podprvoporazeni(int id) {
  /* funkcija ispisuje sve koji su indirektno podredjeni id-u, a sami nikome nisu sefovi */
  int sef, placa, n, podredjeni[68];
  radnik(id, &sef, &placa, &n, podredjeni);
  if (n) {
    int i;
    for (i = 0; i < n; i++) podprvoporazeni(podredjeni[i]);
  } else
    printf(" %d", id);
}

void prvoporazeni(int id) {
  id = glavni_sef(id);
  if (!id) return; /* nepostojeci zaposlenik */
  podprvoporazeni(id);
}

/*** Grupa C je identicna -- dr_adam je ekvivalentan glavnom sefu, a max treba vratiti najveci n koji se pojavi u rekurzivnim pozivima (ekvivalentno najvecem broju direktno podredjenih) ***/

int max_podredjenih(int id) {
  /* funkcija vraca najveci broj podredjenih za nekog id i sve sefove "pod" njim */
  int sef, placa, n, podredjeni[68], res;
  radnik(id, &sef, &placa, &n, podredjeni);
  res = n;
  if (n) {
    int i;
    for (i = 0; i < n; i++) {
      int m = max_podredjenih(podredjeni[i]);
      if (m > res) res = m;
    }
  }
  return res;
}

int max(int id) {
  id = glavni_sef(id);
  if (!id) return; /* nepostojeci zaposlenik */
  return max_podredjenih(id);
}

/*** Grupa D je identicna -- supertox je ekvivalentan glavnom sefu, a fail treba za svaki spoj, uz rekurzivni poziv za "sastojke", provjeriti i je li neki od sastojaka toksicniji od njega (ekvivalentno sefu koji ima manju placu od svog direktno podredjenog) ***/

int podfail(int id) {
  /* funkcija ispisuje sve sefove  */
  int sef, placa, n, podredjeni[68];
  radnik(id, &sef, &placa, &n, podredjeni);
  if (n) {
    int i, f = 0;
    int sef2, placa2, n2, podredjeni2[68];
    for (i = 0; i < n; i++) {
      radnik(podredjeni[i], &sef2, &placa2, &n2, podredjeni2);
      if (placa2 > placa) f = 1;
      podfail(podredjeni[i]);
    }
    if (f) printf(" %d", id);
  }
}

int fail(int id) {
  id = glavni_sef(id);
  if (!id) return; /* nepostojeci zaposlenik */
  return podfail(id);
}

/*** Glavni program za isprobati ***/

int main(void) {
  int i;

  /* Kontrolni ispis podataka */
  printf(" Id Sef   Placa Gl.sef Direktno podredjeni\n");
  printf("------------------------------------------\n");
  for (i = 1; i <= 37; i++) {
    int sef, placa, n, podredjeni[68], j;
    if (radnik(i, &sef, &placa, &n, podredjeni)) {
      printf("%3d %3d %7d %4d   ", i, sef, placa, glavni_sef(i));
      /* printf("%3d %3d %7d %4d   ", i, sef, placa, glavni_sef_rekurzivna_verzija(i)); */
      if (n) {
        for (j = 0; j < n; j++) printf("%s%d", j ? ", " : " ", podredjeni[j]);
        printf("\n");
      } else
        printf(" -\n");
      printf("    Svi sefovi:");
      svi_sefovi(i);
      printf("\n    Svi bez podredjenih (isto sto i prvoporazeni):");
      prvoporazeni(i);
      printf("\n    Max (isto sto i najvise studenata): %d\n", max(i));
      printf("    Fail:");
      fail(i);
      printf("\n");
    }
  }
  return 0;
}
